/**********************************************************************
 * LeechCraft - modular cross-platform feature rich internet client.
 * Copyright (C) 2006-2014  Georg Rudoy
 *
 * Boost Software License - Version 1.0 - August 17th, 2003
 *
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 *
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 **********************************************************************/

#ifndef PLUGINS_AGGREGATOR_FEEDSETTINGS_H
#define PLUGINS_AGGREGATOR_FEEDSETTINGS_H
#include <memory>
#include <QDialog>
#include <QModelIndex>
#include <util/tags/tagscompleter.h>
#include "ui_feedsettings.h"
#include "common.h"

namespace LeechCraft
{
namespace Aggregator
{
	class FeedSettings : public QDialog
	{
		Q_OBJECT

		Ui::FeedSettings Ui_;
		std::auto_ptr<LeechCraft::Util::TagsCompleter> ChannelTagsCompleter_;
		QModelIndex Index_;
		IDType_t SettingsID_;
	public:
		FeedSettings (const QModelIndex&, QWidget* = 0);
	public slots:
		virtual void accept ();
	private slots:
		void on_UpdateFavicon__released ();
	};
}
}

#endif
